/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.benutzerverwaltung.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class BenutzerUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final String benutzerkennung;

    public String getBenutzerkennung(){
      return benutzerkennung;
    }

  protected final de.ivu.elect.business.mandant.entity.MandantUK mandantUK;

    public de.ivu.elect.business.mandant.entity.MandantUK getMandantUK(){
      return mandantUK;
    }

  public BenutzerUK(
String benutzerkennung
,   de.ivu.elect.business.mandant.entity.MandantUK mandantUK
  ) {
    super();


      this.benutzerkennung = benutzerkennung;
        this.mandantUK = mandantUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((benutzerkennung == null) ? 0 : benutzerkennung.hashCode());
        
                    result = result + ((mandantUK == null) ? 0 : mandantUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            BenutzerUK other = (BenutzerUK) obj;

                if (benutzerkennung == null) {
          if (other.benutzerkennung != null) {
            return false;
          }
        } else if (!benutzerkennung.equals(other.benutzerkennung)) {
          return false;
        }
        
                if (mandantUK == null) {
          if (other.mandantUK != null) {
            return false;
          }
        } else if (!mandantUK.equals(other.mandantUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return BenutzerConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(mandantUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BenutzerConstants.MESSAGE_KEY_ENTITY_EINZAHL, BenutzerConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, benutzerkennung));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "BenutzerUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"benutzerkennung="+benutzerkennung
                                        +", "                +"mandantUK="+mandantUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(benutzerkennung);
     return list;
   }

            public static <E extends Benutzer> java.util.Map<BenutzerUK, E> mappeBenutzerNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Benutzer::getBenutzerUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Benutzer, BenutzerUK> getBenutzerToUKFunction() {
                return Benutzer::getBenutzerUK;
                }

}
